import { iterate, delay, map, rangeNumber } from "./fable-library.2.4.11/Seq";
import { parse } from "./fable-library.2.4.11/Int32";
import { toText, printf } from "./fable-library.2.4.11/String";
export function nodeListToHTMLElements(nodeList) {
  return delay(function () {
    return map(function (i) {
      return nodeList[i];
    }, rangeNumber(0, 1, nodeList.length - 1));
  });
}
export function testMutationObserver() {
  document.body.insertAdjacentHTML("beforeEnd", "<ol/>");
  const ol = document.body.lastChild;
  document.body.insertAdjacentHTML("beforeEnd", "<input value='3'/>");
  const volume = document.body.lastChild;
  document.body.insertAdjacentHTML("beforeEnd", "<input value='add' type='button'/>");
  const button = document.body.lastChild;
  window.scrollTo(0, document.body.scrollHeight);
  button.addEventListener("click", function (_arg1) {
    for (let i$$1 = 0; i$$1 <= parse(volume.value, 511, false, 32); i$$1++) {
      let html;
      const clo1 = toText(printf("<li>%i</li>"));
      html = clo1(i$$1);
      ol.insertAdjacentHTML("beforeEnd", html);
    }

    window.scrollTo(0, document.body.scrollHeight);
  });
  const o = new MutationObserver(function (mutations, observer) {
    iterate(function (mutation) {
      console.log(mutation.addedNodes.length);
    }, mutations);
  });
  const options = {
    childList: true
  };
  o.observe(ol, options);
}
testMutationObserver();