import { mapIndexed, map as map$$2, fold, iterate } from "../fable-library.2.4.11/Seq";
import { empty, map as map$$3, tryFind, add, toList } from "../fable-library.2.4.11/Map";
import { toString as toString$$1 } from "../fable-library.2.4.11/Date";
import { toString as toString$$2 } from "../fable-library.2.4.11/TimeSpan";
import { comparePrimitives, Lazy, mapCurriedArgs, uncurry } from "../fable-library.2.4.11/Util";
import { defaultArg, defaultArgWith, map } from "../fable-library.2.4.11/Option";
import { declare, FSharpRef } from "../fable-library.2.4.11/Types";
import { type, getGenerics, getGenericTypeDefinition, getTupleFields, getTupleElements, isTuple, isGenericType, getEnumUnderlyingType, isEnum, getElementType, isArray, getUnionCaseFields, getUnionFields, isUnion, getRecordField, name, getRecordElements, isRecord, fullName } from "../fable-library.2.4.11/Reflection";
import { Util$$$CachedEncoders as Util$0024$0024$0024CachedEncoders, Util$002ECache$00601$$GetOrAdd$$43981464 as Util$0024002ECache$002400601$0024$0024GetOrAdd$0024$002443981464, CaseStrategy, Util$002ECasing$$$convert as Util$0024002ECasing$0024$0024$0024convert } from "./Types";
import { fill, map as map$$1 } from "../fable-library.2.4.11/Array";
import { toFail, toText, printf } from "../fable-library.2.4.11/String";
export function guid(value) {
  return value;
}
export function decimal(value$$1) {
  const value$$2 = String(value$$1);
  return value$$2;
}
export const nil = null;
export function object(values) {
  const o = {};
  iterate(function (forLoopVar) {
    o[forLoopVar[0]] = forLoopVar[1];
  }, values);
  return o;
}
export function list(values$$1) {
  return Array.from(values$$1);
}
export function seq(values$$2) {
  return Array.from(values$$2);
}
export function dict(values$$3) {
  let values$$4;
  values$$4 = toList(values$$3);
  return object(values$$4);
}
export function bigint(value$$5) {
  return String(value$$5);
}
export function datetimeOffset(value$$6) {
  const value$$7 = toString$$1(value$$6, "O", {});
  return value$$7;
}
export function timespan(value$$9) {
  const value$$10 = toString$$2(value$$9);
  return value$$10;
}
export function sbyte(value$$12) {
  return String(value$$12);
}
export function byte$(value$$13) {
  return String(value$$13);
}
export function int16(value$$14) {
  return String(value$$14);
}
export function uint16(value$$15) {
  return String(value$$15);
}
export function int64(value$$16) {
  return String(value$$16);
}
export function uint64(value$$17) {
  return String(value$$17);
}
export function unit() {
  return null;
}
export function tuple2(enc1, enc2, v1, v2) {
  return [enc1(v1), enc2(v2)];
}
export function tuple3(enc1$$1, enc2$$1, enc3, v1$$1, v2$$1, v3) {
  return [enc1$$1(v1$$1), enc2$$1(v2$$1), enc3(v3)];
}
export function tuple4(enc1$$2, enc2$$2, enc3$$1, enc4, v1$$2, v2$$2, v3$$1, v4) {
  return [enc1$$2(v1$$2), enc2$$2(v2$$2), enc3$$1(v3$$1), enc4(v4)];
}
export function tuple5(enc1$$3, enc2$$3, enc3$$2, enc4$$1, enc5, v1$$3, v2$$3, v3$$2, v4$$1, v5) {
  return [enc1$$3(v1$$3), enc2$$3(v2$$3), enc3$$2(v3$$2), enc4$$1(v4$$1), enc5(v5)];
}
export function tuple6(enc1$$4, enc2$$4, enc3$$3, enc4$$2, enc5$$1, enc6, v1$$4, v2$$4, v3$$3, v4$$2, v5$$1, v6) {
  return [enc1$$4(v1$$4), enc2$$4(v2$$4), enc3$$3(v3$$3), enc4$$2(v4$$2), enc5$$1(v5$$1), enc6(v6)];
}
export function tuple7(enc1$$5, enc2$$5, enc3$$4, enc4$$3, enc5$$2, enc6$$1, enc7, v1$$5, v2$$5, v3$$4, v4$$3, v5$$2, v6$$1, v7) {
  return [enc1$$5(v1$$5), enc2$$5(v2$$5), enc3$$4(v3$$4), enc4$$3(v4$$3), enc5$$2(v5$$2), enc6$$1(v6$$1), enc7(v7)];
}
export function tuple8(enc1$$6, enc2$$6, enc3$$5, enc4$$4, enc5$$3, enc6$$2, enc7$$1, enc8, v1$$6, v2$$6, v3$$5, v4$$4, v5$$3, v6$$2, v7$$1, v8) {
  return [enc1$$6(v1$$6), enc2$$6(v2$$6), enc3$$5(v3$$5), enc4$$4(v4$$4), enc5$$3(v5$$3), enc6$$2(v6$$2), enc7$$1(v7$$1), enc8(v8)];
}
export function Enum$$$byte(value$$18) {
  return byte$(value$$18);
}
export function Enum$$$sbyte(value$$20) {
  return sbyte(value$$20);
}
export function Enum$$$int16(value$$22) {
  return int16(value$$22);
}
export function Enum$$$uint16(value$$24) {
  return uint16(value$$24);
}
export function Enum$$$int(value$$26) {
  return value$$26;
}
export function Enum$$$uint32(value$$29) {
  return value$$29;
}
export function datetime(value$$32) {
  const value$$33 = toString$$1(value$$32, "O", {});
  return value$$33;
}
export function toString(space, value$$35) {
  return JSON.stringify(value$$35, uncurry(2, null), space);
}
export function option(encoder) {
  return function ($arg$$1) {
    let option$$2;
    option$$2 = map(encoder, $arg$$1);
    return defaultArgWith(option$$2, function defThunk() {
      return nil;
    });
  };
}

function autoEncodeRecordsAndUnions(extra, caseStrategy, skipNullField, t) {
  const encoderRef = new FSharpRef(null);
  let extra$$1;
  const key$$1 = fullName(t);
  extra$$1 = add(key$$1, encoderRef, extra);
  let encoder$$1;

  if (isRecord(t, true)) {
    let setters;
    const array$$1 = getRecordElements(t, true);
    setters = map$$1(function mapping(fi) {
      const targetKey = Util$0024002ECasing$0024$0024$0024convert(caseStrategy, name(fi));
      const encode$$1 = autoEncoder(extra$$1, caseStrategy, skipNullField, fi[1]);
      return function (source) {
        return function (target) {
          const value$$36 = getRecordField(source, fi);

          if (!skipNullField ? true : skipNullField ? !(value$$36 == null) : false) {
            target[targetKey] = encode$$1(value$$36);
          }

          return target;
        };
      };
    }, array$$1, Array);

    encoder$$1 = function (source$$1) {
      const state = {};
      return fold(uncurry(2, mapCurriedArgs(function folder(target$$1) {
        return function (set) {
          return set(source$$1, target$$1);
        };
      }, [0, [0, 2]])), state, setters);
    };
  } else if (isUnion(t, true)) {
    encoder$$1 = function (value$$37) {
      const patternInput = getUnionFields(value$$37, t, true);
      const matchValue = patternInput[1].length | 0;

      if (matchValue === 0) {
        const value$$38 = name(patternInput[0]);
        return value$$38;
      } else {
        const fieldTypes = getUnionCaseFields(patternInput[0]);
        const target$$2 = fill(new Array(matchValue + 1), 0, matchValue + 1, null);
        const value$$39 = name(patternInput[0]);
        target$$2[0] = value$$39;

        for (let i = 1; i <= matchValue; i++) {
          const encode$$2 = autoEncoder(extra$$1, caseStrategy, skipNullField, fieldTypes[i - 1][1]);
          target$$2[i] = encode$$2(patternInput[1][i - 1]);
        }

        return target$$2;
      }
    };
  } else {
    let message;
    const arg10 = fullName(t);
    const clo1 = toText(printf("Cannot generate auto encoder for %s. Please pass an extra encoder."));
    message = clo1(arg10);
    throw new Error(message);
  }

  encoderRef.contents = encoder$$1;
  return encoder$$1;
}

function autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$1) {
  var clo1$$1;
  const fullname = fullName(t$$1);
  const matchValue$$1 = tryFind(fullname, extra$$2);

  if (matchValue$$1 == null) {
    if (isArray(t$$1)) {
      let encoder$$2;
      const t$$2 = getElementType(t$$1);
      encoder$$2 = autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$2);
      return function (value$$40) {
        let values$$6;
        values$$6 = map$$2(encoder$$2, value$$40);
        return seq(values$$6);
      };
    } else if (isEnum(t$$1)) {
      const enumType = fullName(getEnumUnderlyingType(t$$1));

      if (enumType === "System.SByte") {
        return sbyte;
      } else if (enumType === "System.Byte") {
        return byte$;
      } else if (enumType === "System.Int16") {
        return int16;
      } else if (enumType === "System.UInt16") {
        return uint16;
      } else if (enumType === "System.Int32") {
        return function d$$4(value$$45) {
          return value$$45;
        };
      } else if (enumType === "System.UInt32") {
        return function d$$5(value$$47) {
          return value$$47;
        };
      } else {
        return (clo1$$1 = toFail(printf("Cannot generate auto encoder for %s.\nThoth.Json.Net only support the folluwing enum types:\n- sbyte\n- byte\n- int16\n- uint16\n- int\n- uint32\nIf you can't use one of these types, please pass an extra encoder.\n                    ")), function (arg10$$1) {
          const clo2 = clo1$$1(arg10$$1);
          return function (arg20) {
            return clo2(arg20);
          };
        })(fullName(t$$1));
      }
    } else if (isGenericType(t$$1)) {
      if (isTuple(t$$1)) {
        let encoders;
        const array$$2 = getTupleElements(t$$1);
        encoders = map$$1(function mapping$$1(t$$3) {
          return autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$3);
        }, array$$2, Array);
        return function (value$$49) {
          let values$$7;
          const source$$4 = getTupleFields(value$$49);
          values$$7 = mapIndexed(function mapping$$2(i$$1, x) {
            return encoders[i$$1](x);
          }, source$$4);
          return seq(values$$7);
        };
      } else {
        const fullname$$1 = fullName(getGenericTypeDefinition(t$$1));

        if (fullname$$1 === "Microsoft.FSharp.Core.FSharpOption`1[System.Object]") {
          const encoder$$4 = new Lazy(function () {
            let d$$6;
            let encoder$$3;
            const t$$4 = getGenerics(t$$1)[0];
            encoder$$3 = autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$4);
            d$$6 = option(encoder$$3);
            return d$$6;
          });
          return function d$$8(value$$50) {
            if (value$$50 == null) {
              return nil;
            } else {
              return encoder$$4.Value(value$$50);
            }
          };
        } else if (fullname$$1 === "Microsoft.FSharp.Collections.FSharpList`1[System.Object]" ? true : fullname$$1 === "Microsoft.FSharp.Collections.FSharpSet`1[System.Object]") {
          let encoder$$5;
          const t$$5 = getGenerics(t$$1)[0];
          encoder$$5 = autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$5);
          return function (value$$51) {
            let values$$8;
            values$$8 = map$$2(encoder$$5, value$$51);
            return seq(values$$8);
          };
        } else if (fullname$$1 === "Microsoft.FSharp.Collections.FSharpMap`2[System.Object,System.Object]") {
          const keyType = getGenerics(t$$1)[0];
          let valueEncoder;
          const t$$6 = getGenerics(t$$1)[1];
          valueEncoder = autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, t$$6);

          if (fullName(keyType) === "System.String" ? true : fullName(keyType) === "System.Guid") {
            return function (value$$52) {
              const state$$1 = {};
              return fold(function folder$$1(target$$3, _arg1$$1) {
                const activePatternResult2474 = _arg1$$1;
                target$$3[activePatternResult2474[0]] = valueEncoder(activePatternResult2474[1]);
                return target$$3;
              }, state$$1, value$$52);
            };
          } else {
            let keyEncoder;
            const clo4 = autoEncoder(extra$$2, caseStrategy$$1, skipNullField$$1, keyType);

            keyEncoder = function (arg40) {
              return clo4(arg40);
            };

            return function (value$$53) {
              let values$$10;
              values$$10 = map$$2(function mapping$$3(_arg2) {
                const activePatternResult2478 = _arg2;
                const values$$9 = [keyEncoder(activePatternResult2478[0]), valueEncoder(activePatternResult2478[1])];
                return values$$9;
              }, value$$53);
              return seq(values$$10);
            };
          }
        } else {
          return autoEncodeRecordsAndUnions(extra$$2, caseStrategy$$1, skipNullField$$1, t$$1);
        }
      }
    } else if (fullname === "System.Boolean") {
      return function d$$9(value$$54) {
        return value$$54;
      };
    } else if (fullname === "Microsoft.FSharp.Core.Unit") {
      return function d$$10() {
        return unit();
      };
    } else if (fullname === "System.String") {
      return function d$$11(value$$56) {
        return value$$56;
      };
    } else if (fullname === "System.SByte") {
      return sbyte;
    } else if (fullname === "System.Byte") {
      return byte$;
    } else if (fullname === "System.Int16") {
      return int16;
    } else if (fullname === "System.UInt16") {
      return uint16;
    } else if (fullname === "System.Int32") {
      return function d$$16(value$$62) {
        return value$$62;
      };
    } else if (fullname === "System.UInt32") {
      return function d$$17(value$$64) {
        return value$$64;
      };
    } else if (fullname === "System.Double") {
      return function d$$18(value$$66) {
        return value$$66;
      };
    } else if (fullname === "System.Single") {
      return function d$$19(value$$68) {
        return value$$68;
      };
    } else if (fullname === "System.DateTime") {
      return datetime;
    } else if (fullname === "System.DateTimeOffset") {
      return datetimeOffset;
    } else if (fullname === "System.TimeSpan") {
      return timespan;
    } else if (fullname === "System.Guid") {
      return guid;
    } else if (fullname === "System.Object") {
      return function d$$24(x$$1) {
        return x$$1;
      };
    } else {
      return autoEncodeRecordsAndUnions(extra$$2, caseStrategy$$1, skipNullField$$1, t$$1);
    }
  } else {
    const encoderRef$$1 = matchValue$$1;
    return function (v) {
      return encoderRef$$1.contents(v);
    };
  }
}

function makeExtra(extra$$3) {
  if (extra$$3 != null) {
    const e = extra$$3;
    return map$$3(function (_arg2$$1, tupledArg) {
      return new FSharpRef(tupledArg[0]);
    }, e.Coders);
  } else {
    return empty({
      Compare: comparePrimitives
    });
  }
}

export const Auto = declare(function Thoth_Json_Encode_Auto() {});
export function Auto$reflection() {
  return type("Thoth.Json.Encode.Auto");
}
export function Auto$$$generateEncoderCached$$Z127D9D79(caseStrategy$$2, extra$$4, skipNullField$$2, resolver) {
  const t$$8 = resolver.ResolveType();
  const caseStrategy$$3 = defaultArg(caseStrategy$$2, new CaseStrategy(0, "PascalCase"));
  const skipNullField$$3 = defaultArg(skipNullField$$2, true);
  let key$$2;
  let y$$1;
  const y = fullName(t$$8);
  const x$$2 = String(caseStrategy$$3);
  y$$1 = x$$2 + y;
  let x$$3;
  let option$$4;
  option$$4 = map(function mapping$$4(e$$1) {
    return e$$1.Hash;
  }, extra$$4);
  x$$3 = defaultArg(option$$4, "");
  key$$2 = x$$3 + y$$1;
  const d$$25 = Util$0024002ECache$002400601$0024$0024GetOrAdd$0024$002443981464(Util$0024$0024$0024CachedEncoders, key$$2, function () {
    return autoEncoder(makeExtra(extra$$4), caseStrategy$$3, skipNullField$$3, t$$8);
  });
  return d$$25;
}
export function Auto$$$generateEncoder$$Z127D9D79(caseStrategy$$4, extra$$5, skipNullField$$4, resolver$$2) {
  const caseStrategy$$5 = defaultArg(caseStrategy$$4, new CaseStrategy(0, "PascalCase"));
  const skipNullField$$5 = defaultArg(skipNullField$$4, true);
  let d$$27;
  const t$$9 = resolver$$2.ResolveType();
  const extra$$6 = makeExtra(extra$$5);
  d$$27 = autoEncoder(extra$$6, caseStrategy$$5, skipNullField$$5, t$$9);
  return d$$27;
}
export function Auto$$$toString$$5A41365E(space$$1, value$$75, caseStrategy$$6, extra$$7, skipNullField$$6, resolver$$4) {
  const encoder$$6 = Auto$$$generateEncoder$$Z127D9D79(caseStrategy$$6, extra$$7, skipNullField$$6, resolver$$4);
  const value$$76 = encoder$$6(value$$75);
  return toString(space$$1, value$$76);
}
export function encode(space$$2, value$$77) {
  return toString(space$$2, value$$77);
}