import { ICommandPalette } from "@jupyterlab/apputils";
import * as apputils from "@jupyterlab/apputils";
import * as notebook$$2 from "@jupyterlab/notebook";
import { ILayoutRestorer } from "@jupyterlab/application";
import { createObj, equals, createAtom } from "./fable-library.2.4.11/Util";
import { Widget as Widget$$1 } from "@phosphor/widgets";
import { List, declare, FSharpRef } from "./fable-library.2.4.11/Types";
import * as python from "blockly/python";
import { encodeWorkspace, decodeWorkspace, toolbox, UpdateAllIntellisense_Python, notebooks as notebooks$$3 } from "./Toolbox";
import { type } from "./fable-library.2.4.11/Reflection";
import { idOption, logUrl as logUrl$$1, BlocklyLogEntry082720$$$Create as BlocklyLogEntry082720$0024$0024$0024Create, LogToServer, JupyterLogEntry082720$$$Create as JupyterLogEntry082720$0024$0024$0024Create } from "./Logging";
import * as blockly from "blockly";
import { last } from "./fable-library.2.4.11/Array";
import { trimStart } from "./fable-library.2.4.11/String";
import * as cells from "@jupyterlab/cells";
import { iterate } from "./fable-library.2.4.11/Seq";
import { ofArray } from "./fable-library.2.4.11/List";
export const requires = createAtom([ICommandPalette, notebook$$2.INotebookTracker, ILayoutRestorer]);
export const Widget = Widget$$1;
export const BlocklyWidget = declare(function App_BlocklyWidget(notebooks) {
  const $this$$1 = this;
  Widget$$1.call($this$$1);
  const this$ = new FSharpRef(null);
  $this$$1.notebooks = notebooks;
  this$.contents = $this$$1;
  $this$$1.generator = python;
  const value = $this$$1.notebooks.activeCellChanged.connect(BlocklyWidget$$get_onActiveCellChanged(this$.contents), this$.contents);
  value, null;
  notebooks$$3($this$$1.notebooks);
  const div = document.createElement("div");
  div.setAttribute("style", "height: 480px; width: 600px;");
  div.id = "blocklyDivPython";
  const value$$1 = this$.contents.node.appendChild(div);
  value$$1, null;
  const buttonDiv = document.createElement("div");
  buttonDiv.id = "buttonDivPython";
  const blocksToCodeButton = document.createElement("button");
  blocksToCodeButton.innerText = "Blocks to Code";
  blocksToCodeButton.addEventListener("click", function (_arg1) {
    BlocklyWidget$$RenderCode(this$.contents);
  });
  const value$$2 = buttonDiv.appendChild(blocksToCodeButton);
  value$$2, null;
  const codeToBlocksButton = document.createElement("button");
  codeToBlocksButton.innerText = "Code to Blocks";
  codeToBlocksButton.addEventListener("click", function (_arg2) {
    BlocklyWidget$$RenderBlocks(this$.contents);
  });
  const value$$3 = buttonDiv.appendChild(codeToBlocksButton);
  value$$3, null;
  const bugReportButton = document.createElement("button");
  bugReportButton.innerText = "Report Bug";
  bugReportButton.addEventListener("click", function (_arg3) {
    const win = window.open("https://github.com/aolney/jupyterlab-blockly-python-extension/issues", "_blank");
    win.focus();
  });
  const value$$4 = buttonDiv.appendChild(bugReportButton);
  value$$4, null;
  const syncCheckbox = document.createElement("input");
  syncCheckbox.setAttribute("type", "checkbox");
  syncCheckbox.checked = true;
  syncCheckbox.id = "syncCheckboxPython";
  const syncCheckboxLabel = document.createElement("label");
  syncCheckboxLabel.innerText = "Notebook Sync";
  syncCheckboxLabel.setAttribute("for", "syncCheckboxPython");
  const value$$5 = buttonDiv.appendChild(syncCheckbox);
  value$$5, null;
  const value$$6 = buttonDiv.appendChild(syncCheckboxLabel);
  value$$6, null;
  const value$$7 = this$.contents.node.appendChild(buttonDiv);
  value$$7, null;
  $this$$1["lastCell@"] = null;
  $this$$1["blocksRendered@"] = false;
  $this$$1["workspace@"] = null;
  $this$$1["notHooked@"] = true;
  $this$$1["init@34-1"] = 1;
}, Widget$$1);
export function BlocklyWidget$reflection() {
  return type("App.BlocklyWidget");
}
export function BlocklyWidget$$$$002Ector$$A44FDC6(notebooks) {
  return this instanceof BlocklyWidget ? BlocklyWidget.call(this, notebooks) : new BlocklyWidget(notebooks);
}
export function BlocklyWidget$$get_lastCell(__) {
  return __["lastCell@"];
}
export function BlocklyWidget$$set_lastCell$$Z4422E5A0(__$$1, v) {
  __$$1["lastCell@"] = v;
}
export function BlocklyWidget$$get_blocksRendered(__$$2) {
  return __$$2["blocksRendered@"];
}
export function BlocklyWidget$$set_blocksRendered$$Z1FBCCD16(__$$3, v$$1) {
  __$$3["blocksRendered@"] = v$$1;
}
export function BlocklyWidget$$get_workspace(__$$4) {
  return __$$4["workspace@"];
}
export function BlocklyWidget$$set_workspace$$Z1D3C0780(__$$5, v$$2) {
  __$$5["workspace@"] = v$$2;
}
export function BlocklyWidget$$get_notHooked(__$$6) {
  return __$$6["notHooked@"];
}
export function BlocklyWidget$$set_notHooked$$Z1FBCCD16(__$$7, v$$3) {
  __$$7["notHooked@"] = v$$3;
}
export function BlocklyWidget$$get_Notebooks(this$$$1) {
  return this$$$1.notebooks;
}
export function BlocklyWidget$$get_onKernelExecuted(this$$$2) {
  return function (sender, args) {
    var arg10, arg0, arg10$$1, arg0$$1;

    if (sender.name.indexOf("python") >= 0) {
      const messageType = String(args.header.msg_type);

      if (messageType === "execute_input") {
        console.log("jupyterlab_blockly_extension_python: kernel executed code, updating intellisense");
        LogToServer((arg10 = (arg0 = args.content.code, (arg0)), (JupyterLogEntry082720$0024$0024$0024Create("execute-code", arg10))));
        UpdateAllIntellisense_Python();
      } else if (messageType === "error") {
        LogToServer((arg10$$1 = (arg0$$1 = JSON.stringify(args.content), (arg0$$1)), (JupyterLogEntry082720$0024$0024$0024Create("execute-code-error", arg10$$1))));
      }
    }

    return true;
  };
}
export function BlocklyWidget$$get_onActiveCellChanged(this$$$3) {
  return function (sender$$1, args$$1) {
    var arg10$$2, arg0$$2;

    if (!equals(args$$1, null)) {
      LogToServer((arg10$$2 = (arg0$$2 = args$$1.node.outerText, (arg0$$2)), (JupyterLogEntry082720$0024$0024$0024Create("active-cell-change", arg10$$2))));
      const syncCheckbox$$1 = document.getElementById("syncCheckboxPython");
      const autosaveCheckbox = document.getElementById("autosaveCheckboxPython");

      const isChecked = function isChecked(aCheckbox) {
        if (!equals(aCheckbox, null)) {
          const value$$8 = aCheckbox.checked;
          return value$$8;
        } else {
          return false;
        }
      };

      if (isChecked(syncCheckbox$$1) ? !equals(this$$$3.notebooks.activeCell, null) : false) {
        if (BlocklyWidget$$get_blocksRendered(this$$$3) ? BlocklyWidget$$ActiveCellSerializedBlocksWorkspaceOption(this$$$3) == null : false) {
          BlocklyWidget$$clearBlocks(this$$$3);
        } else {
          BlocklyWidget$$RenderBlocks(this$$$3);
        }

        UpdateAllIntellisense_Python();
      }

      if (isChecked(autosaveCheckbox) ? !equals(this$$$3.notebooks.activeCell, null) : false) {
        BlocklyWidget$$RenderCodeToLastCell(this$$$3);
        BlocklyWidget$$set_lastCell$$Z4422E5A0(this$$$3, args$$1);
      }
    }

    return true;
  };
}

BlocklyWidget.prototype.onAfterAttach = function () {
  const this$$$4 = this;
  BlocklyWidget$$set_workspace$$Z1D3C0780(this$$$4, blockly.inject("blocklyDivPython", {
    toolbox: (toolbox)
  }));
  console.log("jupyterlab_blockly_extension_python: blockly palette initialized");

  const logListener = function logListener(e) {
    var arg00$$3;

    if (e.type === "create") {
      BlocklyWidget$$set_blocksRendered$$Z1FBCCD16(this$$$4, false);
    }

    if (e.type === "finished_loading") {
      BlocklyWidget$$set_blocksRendered$$Z1FBCCD16(this$$$4, true);
    }

    LogToServer((arg00$$3 = e.type, (BlocklyLogEntry082720$0024$0024$0024Create(arg00$$3, e))));
  };

  if (logUrl$$1() != null) {
    console.log("jupyterlab_blockly_extension_python: !!! Logging select blockly actions to server !!!");
  }

  const value$$9 = BlocklyWidget$$get_workspace(this$$$4).removeChangeListener(logListener);
  null, null;
  const value$$10 = BlocklyWidget$$get_workspace(this$$$4).addChangeListener(logListener);
  null, null;
};

BlocklyWidget.prototype.onResize = function (msg) {
  var copyOfStruct, copyOfStruct$$1;
  const this$$$5 = this;
  const blocklyDiv = document.getElementById("blocklyDivPython");
  const buttonDiv$$1 = document.getElementById("buttonDivPython");
  const adjustedHeight = msg.height - 30;
  blocklyDiv.setAttribute("style", "position: absolute; top: 0px; left: 0px; width: " + (copyOfStruct = msg.width, copyOfStruct.toString()) + "px; height: " + adjustedHeight.toString() + "px");
  buttonDiv$$1.setAttribute("style", "position: absolute; top: " + adjustedHeight.toString() + "px; left: " + "0" + "px; width: " + (copyOfStruct$$1 = msg.width, copyOfStruct$$1.toString()) + "px; height: " + "30" + "px");
  blockly.svgResize(BlocklyWidget$$get_workspace(this$$$5));
};

export function BlocklyWidget$$ActiveCellSerializedBlocksWorkspaceOption(this$$$6) {
  if (!equals(this$$$6.notebooks.activeCell, null)) {
    let xmlStringOption;
    let xmlStringComment;
    const array = this$$$6.notebooks.activeCell.model.value.text.split("\n");
    xmlStringComment = last(array);

    if (xmlStringComment.indexOf("xmlns") >= 0) {
      const arg0$$4 = trimStart(xmlStringComment, "#");
      xmlStringOption = arg0$$4;
    } else {
      xmlStringOption = null;
    }

    return xmlStringOption;
  } else {
    return null;
  }
}
export function BlocklyWidget$$RenderBlocks(this$$$7) {
  var arg10$$4;

  if (!equals(this$$$7.notebooks.activeCell, null)) {
    let xmlStringOption$$1;
    let xmlStringComment$$1;
    const array$$1 = this$$$7.notebooks.activeCell.model.value.text.split("\n");
    xmlStringComment$$1 = last(array$$1);

    if (xmlStringComment$$1.indexOf("xmlns") >= 0) {
      const arg0$$5 = trimStart(xmlStringComment$$1, "#");
      xmlStringOption$$1 = arg0$$5;
    } else {
      xmlStringOption$$1 = null;
    }

    try {
      if (xmlStringOption$$1 == null) {} else {
        const xmlString = xmlStringOption$$1;
        BlocklyWidget$$clearBlocks(this$$$7);
        decodeWorkspace(xmlString);
        LogToServer((arg10$$4 = (xmlString), (JupyterLogEntry082720$0024$0024$0024Create("xml-to-blocks", arg10$$4))));
      }
    } catch (e$$1) {
      window.alert("Unable to perform 'Code to Blocks': XML is either invald or renames existing variables. Specific error message is: " + e$$1.message);
      console.log("jupyterlab_blockly_extension_python: unable to decode blocks, last line is invald xml");
    }
  } else {
    console.log("jupyterlab_blockly_extension_python: unable to decode blocks, active cell is null");
  }
}
export function BlocklyWidget$$RenderCode(this$$$8) {
  var arg00$$5, arg10$$5, arg0$$7;
  const code = this$$$8.generator.workspaceToCode(BlocklyWidget$$get_workspace(this$$$8));

  if (!equals(this$$$8.notebooks.activeCell, null)) {
    if (arg00$$5 = this$$$8.notebooks.activeCell.model, (cells.isMarkdownCellModel(arg00$$5))) {
      window.alert("You are calling 'Blocks to Code' on a MARKDOWN cell. Select an empty CODE cell and try again.");
    } else {
      this$$$8.notebooks.activeCell.model.value.text = code + "\n#" + encodeWorkspace();
      console.log("jupyterlab_blockly_extension_python: wrote to active cell\n" + code + "\n");
      LogToServer((arg10$$5 = (arg0$$7 = this$$$8.notebooks.activeCell.model.value.text, (arg0$$7)), (JupyterLogEntry082720$0024$0024$0024Create("blocks-to-code", arg10$$5))));
      BlocklyWidget$$set_blocksRendered$$Z1FBCCD16(this$$$8, true);
    }
  } else {
    console.log("jupyterlab_blockly_extension_python: no cell active, flushed\n" + code + "\n");
  }
}
export function BlocklyWidget$$RenderCodeToLastCell(this$$$9) {
  var arg00$$7, array$$2, arg10$$6, arg0$$8;
  const code$$1 = this$$$9.generator.workspaceToCode(BlocklyWidget$$get_workspace(this$$$9));

  if (!equals(BlocklyWidget$$get_lastCell(this$$$9), null)) {
    if (!equals(BlocklyWidget$$get_lastCell(this$$$9).model, null)) {
      if (arg00$$7 = BlocklyWidget$$get_lastCell(this$$$9).model, (cells.isCodeCellModel(arg00$$7))) {
        let alreadySerialized;

        try {
          alreadySerialized = (array$$2 = BlocklyWidget$$get_lastCell(this$$$9).model.value.text.split("\n"), (last(array$$2))).indexOf("xmlns") >= 0;
        } catch (matchValue) {
          alreadySerialized = false;
        }

        if (alreadySerialized) {
          const workspace = BlocklyWidget$$get_workspace(this$$$9);
          const blocks = BlocklyWidget$$get_workspace(this$$$9).getAllBlocks(false);

          if (blocks.length > 0) {
            BlocklyWidget$$get_lastCell(this$$$9).model.value.text = code$$1 + "\n#" + encodeWorkspace();
            console.log("jupyterlab_blockly_extension_python: wrote to active cell\n" + code$$1 + "\n");
            LogToServer((arg10$$6 = (arg0$$8 = this$$$9.notebooks.activeCell.model.value.text, (arg0$$8)), (JupyterLogEntry082720$0024$0024$0024Create("blocks-to-code-autosave", arg10$$6))));
          }
        }
      }
    }
  } else {
    console.log("jupyterlab_blockly_extension_python: no cell active, flushed instead of autosave\n" + code$$1 + "\n");
  }
}

function BlocklyWidget$$clearBlocks(this$$$10) {
  const workspace$$1 = blockly.getMainWorkspace();
  const blocks$$1 = workspace$$1.getAllBlocks(false);
  iterate(function (b) {
    b.dispose(false);
  }, blocks$$1);
}

export function createMainAreaWidget(bw) {
  const w = new apputils.MainAreaWidget({
    content: bw
  });
  w.id = "blockly-jupyterlab-python";
  w.title.label = "Blockly Python";
  w.title.closable = true;
  return w;
}
export function attachWidget(app, notebooks$$1, widget) {
  var value$$11, arg0$$9;

  if (value$$11 = widget.isAttached, (!value$$11)) {
    const matchValue$$1 = notebooks$$1.currentWidget;

    if (matchValue$$1 == null) {
      app.shell.add(widget, "main");
    } else {
      const c = matchValue$$1;
      const options = {
        ref: (arg0$$9 = c.id, (arg0$$9)),
        mode: ("split-left")
      };
      const value$$12 = c.context.addSibling(widget, options);
      value$$12, null;
    }
  }

  app.shell.activateById(widget.id);
}
export function runCommandOnNotebookChanged(sender$$2, args$$2) {
  const matchValue$$2 = sender$$2.currentWidget;

  if (matchValue$$2 == null) {} else {
    const notebook = matchValue$$2;
    console.log("jupyterlab_blockly_extension_python: notebook changed, autorunning blockly python command");
    const value$$13 = this.commands.execute("blockly_python:open");
    value$$13, null;
  }

  return true;
}
export function onKernelChanged(sender$$3, args$$3) {
  const widget$$1 = this;

  if (BlocklyWidget$$get_notHooked(widget$$1)) {
    const matchValue$$3 = sender$$3.kernel;

    if (matchValue$$3 == null) {} else {
      const kernel = matchValue$$3;

      if (kernel.name.indexOf("python") >= 0) {
        const value$$14 = kernel.iopubMessage.connect(BlocklyWidget$$get_onKernelExecuted(widget$$1), widget$$1);
        value$$14, null;
        console.log("jupyterlab_blockly_extension_python: Listening for kernel messages");
        BlocklyWidget$$set_notHooked$$Z1FBCCD16(widget$$1, false);
      }
    }

    return true;
  } else {
    return false;
  }
}
export function onNotebookChanged(sender$$4, args$$4) {
  var arg10$$7, arg0$$11;
  const blocklyWidget = this;
  const matchValue$$4 = sender$$4.currentWidget;

  if (matchValue$$4 == null) {} else {
    const notebook$$1 = matchValue$$4;
    console.log("jupyterlab_blockly_extension_python: notebook changed to " + notebook$$1.context.path);
    LogToServer((arg10$$7 = (arg0$$11 = notebook$$1.context.path, (arg0$$11)), (JupyterLogEntry082720$0024$0024$0024Create("notebook-changed", arg10$$7))));
    const value$$15 = notebook$$1.session.kernelChanged.connect(onKernelChanged, blocklyWidget);
    value$$15, null;
  }

  return true;
}
export const extension = {
  id: "jupyterlab_blockly_extension_python",
  autoStart: true,
  requires: requires(),
  activate: function (app$$1, palette, notebooks$$2, restorer) {
    var fields, fields$$1, state;
    console.log("jupyterlab_blockly_extension_python: activated");
    const blocklyWidget$$1 = BlocklyWidget$$$$002Ector$$A44FDC6(notebooks$$2);
    let widget$$2 = createMainAreaWidget(blocklyWidget$$1);
    const tracker = new apputils.WidgetTracker((fields = new List(["namespace", "blockly_python"], new List()), (createObj(fields, 0))));
    const value$$16 = restorer.restore(tracker, (fields$$1 = ofArray([["command", "blockly_python:open"], ["name", function () {
      return "blockly_python";
    }]]), (createObj(fields$$1, 0))));
    value$$16, null;
    const value$$17 = notebooks$$2.currentChanged.connect(onNotebookChanged, blocklyWidget$$1);
    value$$17, null;
    const value$$20 = app$$1.commands.addCommand("blockly_python:open", {
      label: "Blockly Python",

      execute() {
        var value$$18;

        if (equals(widget$$2, null) ? true : widget$$2.isDisposed) {
          widget$$2 = createMainAreaWidget(blocklyWidget$$1);
        }

        const widget$$3 = widget$$2;
        attachWidget(app$$1, notebooks$$2, widget$$3);

        if (value$$18 = tracker.has(widget$$2), (!value$$18)) {
          const value$$19 = tracker.add(widget$$2);
          value$$19, null;
        }
      }

    });
    value$$20, null;
    palette.addItem({
      command: "blockly_python:open",
      category: "Blockly"
    });
    const searchParams = new URLSearchParams(window.location.search);
    const matchValue$$5 = searchParams.get("bl");
    var $target$$34;

    if (matchValue$$5 != null) {
      if (state = matchValue$$5, state === "1") {
        $target$$34 = 0;
      } else {
        $target$$34 = 1;
      }
    } else {
      $target$$34 = 1;
    }

    switch ($target$$34) {
      case 0:
        {
          console.log("jupyterlab_blockly_extension_python: triggering open command based on query string input");
          const value$$22 = app$$1.restored.then(function () {
            const value$$21 = notebooks$$2.currentChanged.connect(runCommandOnNotebookChanged, app$$1);
            value$$21, null;
            widget$$2.title.closable = false;
          });
          value$$22, null;
          break;
        }
    }

    const matchValue$$6 = searchParams.get("id");

    if (matchValue$$6 != null) {
      const id = matchValue$$6;
      idOption(id);
    }

    const matchValue$$7 = searchParams.get("log");

    if (matchValue$$7 != null) {
      const logUrl = matchValue$$7;
      logUrl$$1(logUrl);
    }
  }
};
export default extension;